---
title: Xamarin.Android error APT0001
description: APT0001 error code
ms.date: 03/31/2020
---
# Xamarin.Android error APT0001

## Example messages

```
error APT0001: Unknown option `--ignore-assets`. Please check `$(AndroidAapt2CompileExtraArgs)` and `$(AndroidAapt2LinkExtraArgs)` to see if they include any `aapt` command line arguments that are no longer valid for `aapt2` and ensure that all other arguments are valid for `aapt2`.
```

## Issue

The new Android `aapt2` resource tool has different commandline arguments to the
older `aapt` tool. These are generally incompatible with each other.

## Solution

If you are receiving this error, check that the values provided in

```xml
<AndroidAapt2LinkExtraArgs/>
<AndroidAapt2CompileExtraArgs>
```

are valid for `aapt2`. You can use `aapt2 compile` and `aapt2 link` to view
the list of valid arguments.
