---
title: Xamarin.Android warning XA2000
description: XA2000 warning code
ms.date: 1/13/2019
---
# Xamarin.Android warning XA2000

## Example messages

```
Use of AppDomain.CreateDomain() detected in assembly: {assembly}. .NET 6 will only support a single AppDomain, so this API will no longer be available in Xamarin.Android once .NET 6 is released.
```

## Solution

Transition code away from `AppDomain.CreateDomain()` to a different API, such as [`AssemblyLoadContext`][unloadability].

[unloadability]: https://docs.microsoft.com/dotnet/standard/assembly/unloadability
